#include<bits/stdc++.h>

using namespace std;

int n;
int poljana[2005][2005];
bool prosao[1000005];
int koliko[1000005];
int k,s,l;
int krajr,krajk;
int tren,res;

int main()
{
    ios_base::sync_with_stdio(false);
    cin >> n >> k ;
    for(int i=0;i<n;i++)
        for(int j=0;j<n;j++)
    {
        cin >> poljana[i][j];
        koliko[poljana[i][j]]++;
    }
    for(int i=0;i<n;i++)
        for(int j=0;j<n;j++)
    {
        if(!prosao[poljana[i][j]])
        {
            tren=0;
            krajr=j;
            while(krajr<n && poljana[i][j]==poljana[i][krajr])
                krajr++;
            krajk=i+1;
            while(krajk<n && poljana[krajk][j]==poljana[i][j])
                krajk++;
            prosao[poljana[i][j]]=true;
            for(l=i;l<krajk;l++)
                for(s=j;s<krajr;s++)
            {
                if(poljana[l][s]!=poljana[i][j])
                {
                    l=krajk+1;
                    s=krajr;
                }
            }
            if(l!=krajk+1 && (krajk-i)*(krajr-j)==koliko[poljana[i][j]])
                res++;
        }
    }
    cout << res << endl;
}